from collections import defaultdict as ddict
import re
import ss

sensors = ddict(list)
regexp = re.compile('(\w+)__(\w+)__(\w+)__(\w+)')

for sensor in ss.sensors:
    m = regexp.search( sensor )
    server, db, group, mask = m.groups()
    idx = '%s.%s.%s' % (server,db,group)
    sensors[idx].append(mask)

configs = []
url = 'http://katrin.kit.edu/adei-katrin'

for s in sensors:
    server, db, group = s.split('.')
    config = dict(url=url, server=server, database=db, sensors=sensors[s], group=group)
    configs.append(config)
